#!/bin/sh
# Build a cross-compiler

if [ ! "$MUSL_CC_BASE" ]
then
    MUSL_CC_BASE=`dirname "$0"`/..
fi

# Fail on any command failing, show commands:
set -ex

. "$MUSL_CC_BASE"/defs.sh

PREFIX="$CC_PREFIX"

bootstrap() {
    BD="$1"
    BUILT="$PWD/$BD/built"
    shift

    if [ ! -e "$BUILT" ]
    then
        patch_source "$BD"

        (
        cd "$BD" || die "Failed to cd $BD"
	export CC CXX GNATMAKE GNATBIND GNATLS GNATLINK

	# these directories are not created by old versions of install
	# these 3 lines need to be moved to bootstrap.sh of gprbuild
	mkdir -p $PREFIX/libexec/gprbuild
	mkdir -p $PREFIX/share/gprconfig
	mkdir -p $PREFIX/share/gpr

        (./bootstrap.sh --prefix="$PREFIX" --with-xmlada=../xmlada-gpl-2017-src &&
            touch "$BUILT" ) ||
            die "Failed to build $BD"
        )
    fi
}

fetch() {
    if [ ! -e "$MUSL_CC_BASE/tarballs/$2" ]
    then
        wget -O "$MUSL_CC_BASE/tarballs/$2.part" -c "$1"
        mv "$MUSL_CC_BASE/tarballs/$2.part" "$MUSL_CC_BASE/tarballs/$2"
    fi
    return 0
}

XMLADA=http://mirrors.cdn.adacore.com/art/591aeb88c7a4473fcbb154f8
GPRBUILD=http://mirrors.cdn.adacore.com/art/591c45e2c7a447af2deecff7

fetchextract $XMLADA xmlada-gpl-2017-src .tar.gz
fetchextract $GPRBUILD gprbuild-gpl-2017-src .tar.gz

bootstrap gprbuild-gpl-2017-src 
