#!/bin/sh

if [ ! "$MUSL_CC_BASE" ]
then
    MUSL_CC_BASE=`dirname "$0"`/..
fi

set -ex

touch extraconfig.sh

if [ ! "$2" ]
then
    echo 'Use: .../cc-gprbuild.sh <install prefix> archs'
    exit 1
fi

PREFIX_BASE="$1"
shift
NATIVE_ARCH="$1"

for ARCH in "$@"
do
    case "$ARCH" in
        armhf)
            TRIPLE="arm-linux-musleabihf"
            ;;
        arm*)
            TRIPLE="$ARCH-linux-musleabi"
            ;;
        x32)
            TRIPLE="x86_64-x32-linux-musl"
            ;;
        *)
            TRIPLE="$ARCH-linux-musl"
            ;;
    esac


NATIVE_CROSS="$PREFIX_BASE/$TRIPLE/bin/$TRIPLE"

rm -Rf gprbuild-gpl-2017-src/
rm -Rf xmlada-gpl-2017-src/

echo 'ARCH='$ARCH'
TRIPLE='$TRIPLE'
CC_PREFIX="'"$PREFIX_BASE/$TRIPLE-native"'"
MAKEOPTS="'"$MAKEOPTS"'"
CC="'"$NATIVE_CROSS-gcc"' -static -Wl,-Bstatic -static-libgcc"
CXX="'"$NATIVE_CROSS-g++"' -static -Wl,-Bstatic -static-libgcc"
GNATMAKE="'"$NATIVE_CROSS-gnatmake"' -bargs -static -cargs -static -static-libgcc -largs -Wl,-Bstatic -static -static-libgcc -margs"
GNATBIND="'"$NATIVE_CROSS-gnatbind"' -static"
GNATLS="'"$NATIVE_CROSS-gnatls"'"
GNATLINK="'"$NATIVE_CROSS-gnatlink -static -static-libgcc -Wl,-Bstatic"'"
export CC CXX GNATMAKE GNATBIND GNATLS GNATLINK
GCC_BOOTSTRAP_CONFFLAGS=--disable-lto-plugin
GCC_CONFFLAGS=--disable-lto-plugin
. ./extraconfig.sh' > config.sh

        "$MUSL_CC_BASE"/extra/build-gprbuild.sh
done
